//print /flush "Now in " ChangeDir("c:/doc/wp/randy");
new;
library pgraph;
graphset;

#include params.dec;

string sims_fname = "sims";

open fh = ^sims_fname varindxi;
if( fh == -1 );
    print "File not found";
    end;
endif;

_pdate = "";
betas = {};
w_h = {};
a = {};
C_size = {};
hpay = {};
do until eof(fh);
    // beta wh a a_LB a_UB Csize Csize_LB Csize_UB hpay hpay_LB hpay_UB
    d = readr(fh,N_HEGEMON_SIZES);
    a = d[.,ia] ~ a;
    C_size = d[.,iCsize] ~ C_size;
    hpay = d[.,ihpay] ~ hpay;
    if( 0 == rows(w_h) ); w_h = d[.,iwh]; endif;
    betas = d[1,ibeta] ~ betas;
endo;
fh = close(fh);

// rate of increase results
b_idx = cols(betas);
wh_idx = rows(w_h);
a1_small = a[1,1];
a1_large = a[1,b_idx];
C1_small = C_size[1,1];
C1_large = C_size[1,b_idx];

a2_small = a[wh_idx,1];
a2_large = a[wh_idx,b_idx];
C2_small = C_size[wh_idx,1];
C2_large = C_size[wh_idx,b_idx];

format /rd 6,4;
print /flush "Small hegemon (w_h = " w_h[1] "\b)"
        "\n\tconsolidated, aL(beta = " betas[1] "\b) = " a1_small "\b, CL = " C1_small "\b, as %W = " (C1_small/WORLD_SIZE)
        "\n\tfragmented,   aH(beta = " betas[b_idx] "\b) = " a1_large "\b, CH = " C1_large "\b, as %W = " (C1_large/WORLD_SIZE)
        "\n\t--> aH:aL = 1:" (a1_small/a1_large)
        "\n\t--> CH:CL = 1:" (C1_small/C1_large)
        "\nLarge hegemon (w_h = " w_h[wh_idx] "\b)"
        "\n\tconsolidated, aL(beta = " betas[1] "\b) = " a2_small "\b, CL = " C2_small "\b, as %W = " (C2_small/WORLD_SIZE)
        "\n\tfragmented,   aH(beta = " betas[b_idx] "\b) = " a2_large "\b, CH = " C2_large "\b, as %W = " (C2_large/WORLD_SIZE)
        "\n\t--> aH:aL = 1:" (a2_small/a2_large)
        "\n\t--> CH/CL = 1:" (C2_small/C2_large)
        "\nconsolidated, beta = " betas[1] "\b, a(small h):a(large h) = 1:" (a2_small/a1_small)
        "\nfragmented  , beta = " betas[b_idx] "\b, a(small h):a(large h) = 1:" (a2_large/a1_large)
        "\nconsolidated, beta = " betas[1] "\b, C(large h):C(small h) = 1:" (C1_small/C2_small)
        "\nfragmented  , beta = " betas[b_idx] "\b, C(large h):C(small h) = 1:" (C1_large/C2_large);

fonts("complex simgrma");

_pdate = "";
_ptek = "surface.tkf";
_pmcolor = { 0, 0, 0, 0, 0, 0, 0, 0, 15 };
_pqg_ps_WhiteBecomes = 15; // stop the postscript routines from converting white
_pzclr = 1;
_psurf = { 0, 8 };

volume(1,1,1);
view(4,-2,1.75);

// betas is 1xK (x), wh is Nx1 matrix (y)
// a,C_size,hpay are NxK matrices (z)

tsteps = 5;
tmin = floor(minc(betas'));
tmax = ceil(maxc(betas'));
xtics(tmin,tmax,0.5,0);
xlabel("Proportion Small States (\202b\201)");

tmin = floor_fp(minc(w_h),0.05);
tmax = ceil_fp(maxc(w_h),0.05);
ytics(tmin,tmax,0.05,0);
ylabel("Hegemon Size (w]h[)");

tmin = floor_fp( minc(minc(C_size)), 0.05 );
tmax = ceil_fp( maxc(maxc(C_size)), 0.05 );
ztics(tmin,tmax,(tmax-tmin)/tsteps,0);
zlabel("Contributing Coalition Size");

surface(betas,w_h,C_size);
call tkf2ps(_ptek,"../figures/coalition.ps");

tmin = floor_fp( minc(minc(a)), 0.25 );
tmax = ceil_fp( maxc(maxc(a)), 0.25 );
ztics(tmin,tmax,(tmax-tmin)/tsteps,0);
zlabel("Optimal Demand (a[*])");

surface(betas,w_h,a);
call tkf2ps(_ptek,"../figures/demand.ps");
